      program main
      implicit none
      real*8  k_val(3204)
      real*8  m_val(1080)
      integer k_ind(4824)
      integer m_ind(1620)
      integer nx, ne_k, ne_m, nev, ncv, irvec, ierr
      integer Lindex_k, Lvalue_k,  
     &		Lindex_m, Lvalue_m  
      real*8 alfa_r(90)
      real*8 alfa_i(90)
      real*8 z_r(90,8)
      real*8 z_i(90,8)

      Lvalue_k = 3204
      Lvalue_m = 1080
      Lindex_k = 4824
      Lindex_m = 1620
      nx = 90
      ne_k = 268
      ne_m = 90
           
      OPEN (33, FILE="k_val.dat", FORM='BINARY')
      read(33) k_val
      OPEN (33, FILE="m_val.dat", FORM='BINARY')
      read(33) m_val
      OPEN (33, FILE="k_ind.dat", FORM='BINARY')
      read(33) k_ind
      OPEN (33, FILE="m_ind.dat", FORM='BINARY')
      read(33) m_ind

      nev = 6
      ncv = 14
      irvec = 1
      call MKL_EIGS_SPARSE_INPUT(nx, alfa_r, alfa_i, z_r, z_i, 
     &            nev, irvec, 
     &			Lindex_k, Lvalue_k, k_ind, k_val, ne_k, 
     &			Lindex_m, Lvalue_m, m_ind, m_val, ne_m, 
     &			ierr)
      
      end
      
      !      INCLUDE 'mkl.fi'
      subroutine MKL_EIGS_SPARSE_INPUT(nx, alfa_r, alfa_i, z_r, z_i, 
     &            nev, irvec, 
     &			Lindex_k, Lvalue_k, index_k, value_k, ne_k, 
     &			Lindex_m, Lvalue_m, index_m, value_m, ne_m, 
     &			ierr)
!DEC$ ATTRIBUTES DLLEXPORT, STDCALL, REFERENCE :: MKL_EIGS_SPARSE_INPUT
!DEC$ ATTRIBUTES ALIAS:"MKL_EIGS_SPARSE_INPUT" :: MKL_EIGS_SPARSE_INPUT
      implicit none
      INCLUDE 'mkl_pardiso.f77'
      character(10) :: rtn
	integer irvec, ierr, nx, nev
	real*8 alfa_r(nx),alfa_i(nx)
	real*8 z_r(nx,nev+2),z_i(nx,nev+2)
	integer LVALUE_k, LINDEX_k, ne_k, index_k(LINDEX_k)
      integer LVALUE_m, LINDEX_m, ne_m, index_m(LINDEX_m)
	real*8 value_k(LVALUE_k)
      real*8 value_m(LVALUE_m)
      
	logical rvec, rtnchk
      integer ierr_temp
	logical first
	real*8 d(:,:)
	real*8 v(:,:)
	ALLOCATABLE d, v
      integer*8, allocatable :: pt(:)
      integer iparm(64)
	integer i, ncv, j, jj, idum(1)
      real*8 ddum(1)
      integer :: ia_k(nx+1), ja_k(ne_k)   ,   ia_m(nx+1), ja_m(ne_m)
      real*8  :: a_k(ne_k)                ,   a_m(ne_m)
      
      call mkl_dcsrcoo((/2,1,1,0,size(a_k),0,0,0/), nx, a_k, ja_k, ia_k,
     &    ne_k, value_k, index_k(1:ne_k), index_k(ne_k+1:2*ne_k), ierr)
      if( ierr.ne.0 ) return
      call mkl_dcsrcoo((/2,1,1,0,size(a_m),0,0,0/), nx, a_m, ja_m, ia_m,
     &    ne_m, value_m, index_m(1:ne_m), index_m(ne_m+1:2*ne_m), ierr)
      if( ierr.ne.0 ) return
          
      ncv = 14
      
      ALLOCATE ( d(nx,3), v(nx,ncv) )

      allocate( pt(64) )
      pt(:) = 0.d0
	call mkl_LU_factor2(nx, ne_k, a_k, ia_k, ja_k, pt, iparm, ierr)
	if( ierr .ne. 0 ) goto 9999 !a pardiso error

	if( irvec.eq.0 ) then
		rvec=.false.
	else
		rvec=.true.
	endif

      call mkl_dnsimp_sparse_input(nx, d, v, nx, nev, ncv,
     &        ierr, rvec, 
     &		ne_k, a_k, ia_k, ja_k, pt, iparm,
     &		ne_m, a_m, ia_m, ja_m,
     &		'LM')

			if( ierr .ne. 0 ) then
				goto 9999 !could be a pardiso or arpack error
			endif

	jj=0
	first = .true. !for 1st of complex pair
	do 1 j=1,nev
		alfa_r(j) =  real(1./dcmplx(d(j,1),d(j,2)))
		alfa_i(j) = aimag(1./dcmplx(d(j,1),d(j,2)))
c		alfa(j)=1./dcmplx(d(j,1),d(j,2))
c mode shapes are returned only for underdamped modes	
c    	if( d(j,2) .ne. 0. ) then					!comment out 11/12/2004
			if(first) then
				do i=1,nx
c					z(i,j)=dcmplx( v(i,j),v(i,j+1) )
					z_r(i,j) = v(i,j)
					z_i(i,j) = v(i,j+1)
				end do
				first= .false.
				if( d(j,2) .eq. 0. ) then			!add these 3 statements 11/12/2004
					first= .true.				!add these 3 statements 11/12/2004
				endif							!add these 3 statements 11/12/2004
			else
				do i=1,nx
c					z(i,j)=conjg( z(i,j-1) )
					z_r(i,j) =  z_r(i,j-1)
					z_i(i,j) = -z_i(i,j-1)
				end do
				first= .true.
			endif
c	endif										!comment out 11/12/2004
1	continue

c	if( .not. rvec ) call reverse_order_of_evalues(alfa_r,alfa_i,nev)

9999	continue
	DEALLOCATE	( d,v )
      if( allocated(pt) ) then
          call pardiso(pt, 1, 1, 11, -1, nx, ddum, idum, idum, idum, 1,
     &        idum, 0, ddum, ddum, ierr_temp) !use a dummy variable for ierr so the real ierr is not lost
          deallocate( pt)
      endif

	return
	end
				  
!=======================================================================
      subroutine mkl_dnsimp_sparse_input(nsize,d, v, nx,nev,ncv,
     &        ierr_arg, rvec, 
     &		ne_k, a_k, ia_k, ja_k, pt, iparm,
     &		ne_m, a_m, ia_m, ja_m,
     &		which)
      implicit none
	integer nsize, nx, nev, ncv, ierr_arg
      integer ne_k, ia_k(nx+1), ja_k(ne_k)
      integer ne_m, ia_m(nx+1), ja_m(ne_m)
      integer*8 pt(64)
      integer iparm(64)
      real*8 a_k(ne_k)
      real*8 a_m(ne_m)
	real*8 d(nx,3)
	real*8 v(nx,*)
	real*8 resid(nx)
      character which*2  !pass in 'LM' for largest magnitude, 'SM' for smallest

      !mrf for timing tracking
	integer ime

      integer           ldv

c     %--------------%
c     | Local Arrays |
c     %--------------%
c
      integer           iparam(11), ipntr(14)
      logical           select(:)

c      real*8
c     &                  ax(maxn), 
c     &                  d(maxncv,3),
c     &                  resid(maxn), 
c     &                  v(ldv,maxncv),
c     &                  workd(3*maxn), 
c     &                  workev(3*maxncv), 
c     &                  workl(3*maxncv*maxncv+6*maxncv)

	real*8          ax(:), workd(:), workev(:), workl(:)
	ALLOCATABLE     ax   , workd,    workev,    workl,	select 

c     %---------------%
c     | Local Scalars |
c     %---------------%
c
      character         bmat*1
      integer           ido, n, lworkl, info, ierr,
     &                  j, ishfts, maxitr, mode1, nconv
      real*8
     &                  tol, sigmar, sigmai
      logical           first, rvec
c
c     %------------%
c     | Parameters |
c     %------------%
c
      real*8
     &                  zero
      parameter         (zero = 0.0D+0)
c
c     %-----------------------------%
c     | BLAS & LAPACK routines used |
c     %-----------------------------%
c
      real*8
     &                  dlapy2, dnrm2
      external          dlapy2, dnrm2, daxpy 
c
c     %--------------------%
c     | Intrinsic function |
c     %--------------------%
c
      intrinsic         abs
c
c     %-----------------------%
c     | Executable Statements |
c     %-----------------------%
c
c     %-------------------------------------------------%
c     | The following include statement and assignments |
c     | initiate trace output from the internal         |
c     | actions of ARPACK.  See debug.doc in the        |
c     | DOCUMENTS directory for usage.  Initially, the  |
c     | most useful information will be a breakdown of  |
c     | time spent in the various stages of computation |
c     | given by setting mnaupd = 1.                    |
c     %-------------------------------------------------%
c
      include 'debug.h'
      ndigit = -3
      logfil = 6
      mnaitr = 0
      mnapps = 0
      mnaupd = 0       ! 1 for output, 0 to suppress output  
      mnaup2 = 0
      mneigh = 0
      mneupd = 0
c
c     %-------------------------------------------------%
c     | The following sets dimensions for this problem. |
c     %-------------------------------------------------%
c
	ALLOCATE		(   ax(nsize),
     &					workd(3*nsize), 
     &					workev(3*ncv), 
     &					workl(3*ncv**2+6*ncv),
     &					select(nsize)
     &				)

cmrf      nx    = 10 
cmrf      nx    = 24
cmrf      n     = nx*nx 
	n=nx
	ldv=nsize

      bmat  = 'I'
cmrf      which = 'LM'  now passed in 05/25/2013

c     %-----------------------------------------------------%
c     |                                                     |
c     | Specification of stopping rules and initial         |
c     | conditions before calling DNAUPD                    |
c     |                                                     |
c     | TOL  determines the stopping criterion.             |
c     |                                                     |
c     |      Expect                                         |
c     |           abs(lambdaC - lambdaT) < TOL*abs(lambdaC) |
c     |               computed   true                       |
c     |                                                     |
c     |      If TOL .le. 0,  then TOL <- macheps            |
c     |           (machine precision) is used.              |
c     |                                                     |
c     | IDO  is the REVERSE COMMUNICATION parameter         |
c     |      used to specify actions to be taken on return  |
c     |      from DNAUPD. (see usage below)                 |
c     |                                                     |
c     |      It MUST initially be set to 0 before the first |
c     |      call to DNAUPD.                                |
c     |                                                     |
c     | INFO on entry specifies starting vector information |
c     |      and on return indicates error codes            |
c     |                                                     |
c     |      Initially, setting INFO=0 indicates that a     |
c     |      random starting vector is requested to         |
c     |      start the ARNOLDI iteration.  Setting INFO to  |
c     |      a nonzero value on the initial call is used    |
c     |      if you want to specify your own starting       |
c     |      vector (This vector must be placed in RESID).  |
c     |                                                     |
c     | The work array WORKL is used in DNAUPD as           |
c     | workspace.  Its dimension LWORKL is set as          |
c     | illustrated below.                                  |
c     |                                                     |
c     %-----------------------------------------------------%
c
      lworkl  = 3*ncv**2+6*ncv 
      tol    = zero 
      ido    = 0
      info   = 0
c
c     %---------------------------------------------------%
c     | Specification of Algorithm Mode:                  |
c     |                                                   |
c     | This program uses the exact shift strategy        |
c     | (indicated by setting IPARAM(1) = 1).             |
c     | IPARAM(3) specifies the maximum number of Arnoldi |
c     | iterations allowed.  Mode 1 of DNAUPD is used     |
c     | (IPARAM(7) = 1). All these options can be changed |
c     | by the user. For details see the documentation in |
c     | DNAUPD.                                           |
c     %---------------------------------------------------%
c
      ishfts = 1
      maxitr = 300
      mode1 = 1
c
      iparam(1) = ishfts
c
      iparam(3) = maxitr
c
      iparam(7) = mode1
c
c     %-------------------------------------------%
c     | M A I N   L O O P (Reverse communication) | 
c     %-------------------------------------------%
c
	ime=0
 10   continue

c        %---------------------------------------------%
c        | Repeatedly call the routine DNAUPD and take |
c        | actions indicated by parameter IDO until    |
c        | either convergence is indicated or maxitr   |
c        | has been exceeded.                          |
c        %---------------------------------------------%

          call dnaupd ( ido, bmat, n, which, nev, tol, resid, ncv, 
     &                 v, ldv, iparam, ipntr, workd, workl, lworkl, 
     &                 info )

          if (ido .eq. -1 .or. ido .eq. 1) then

c			%-------------------------------------------%
c			| Perform matrix vector multiplication      |
c			|                y <--- Op*x                |
c			| The user should supply his/her own        |
c			| matrix vector multiplication routine here |
c			| that takes workd(ipntr(1)) as the input   |
c			| vector, and return the matrix vector      |
c			| product to workd(ipntr(2)).               | 
c			%-------------------------------------------%

              call mkl_av_2_part_sparse_input(nx, workd(ipntr(1)), 
     &            workd(ipntr(2)), 
     &            ne_k, a_k, ia_k, ja_k, pt, iparm, 
     &            ne_m, a_m, ia_m, ja_m, ierr )
              if ( ierr .ne. 0) then
                  ierr_arg = ierr+200000 !a number near 200000 means a pardiso error
                  goto 9000 !cmrf
              endif
c			%-----------------------------------------%
c			| L O O P   B A C K to call DNAUPD again. |
c			%-----------------------------------------%
c
              ime=ime+1
              go to 10
c
      endif
c     %----------------------------------------%
c     | Either we have convergence or there is |
c     | an error.                              |
c     %----------------------------------------%
c
      if ( info .lt. 0 ) then
          ierr_arg = info+300000 !a number near 300000 means an error returned by arpack's dn-A-upd
		goto 9000
c        %--------------------------%
c        | Error message, check the |
c        | documentation in DNAUPD. |
c        %--------------------------%
      else 
c        %-------------------------------------------%
c        | No fatal errors occurred.                 |
c        | Post-Process using DNEUPD.                |
c        |                                           |
c        | Computed eigenvalues may be extracted.    |
c        |                                           |
c        | Eigenvectors may be also computed now if  |
c        | desired.  (indicated by rvec = .true.)    |
c        |                                           |
c        | The routine DNEUPD now called to do this  |
c        | post processing (Other modes may require  |
c        | more complicated post processing than     |
c        | mode1,)                                   |
c        |                                           |
c        %-------------------------------------------%
c		rvec = .true.  ! this is now passed in
         call dneupd ( rvec, 'A', select, d, d(1,2), v, ldv, 
     &        sigmar, sigmai, workev, bmat, n, which, nev, tol, 
     &        resid, ncv, v, ldv, iparam, ipntr, workd, workl,
     &        lworkl, ierr )
c
c        %------------------------------------------------%
c        | The real parts of the eigenvalues are returned |
c        | in the first column of the two dimensional     |
c        | array D, and the IMAGINARY part are returned   |
c        | in the second column of D.  The corresponding  |
c        | eigenvectors are returned in the first         |
c        | NCONV (= IPARAM(5)) columns of the two         |
c        | dimensional array V if requested.  Otherwise,  |
c        | an orthogonal basis for the invariant subspace |
c        | corresponding to the eigenvalues in D is       |
c        | returned in V.                                 |
c        %------------------------------------------------%
c
         if ( ierr .ne. 0) then
			ierr_arg = ierr+400000 !a number near 400000 means an error returned by arpack's dn-E-upd
			goto 9000 !cmrf
c           %------------------------------------%
c           | Error condition:                   |
         else
            first = .true.
            nconv =  iparam(5)
		  ime=0
         end if !endif no error

      end if
c
c     %---------------------------%
c     | Done with program dnsimp. |
c     %---------------------------%
c
 9000 continue
c
	DEALLOCATE		(   ax,
     &					workd, 
     &					workev, 
     &					workl,
     &					select
     &				)
      end

!======================================================================
      subroutine mkl_av_2_part_sparse_input(nx, v, r, 
     &				ne_k, a_k, ia_k, ja_k, pt, iparm,
     &				ne_m, a_m, ia_m, ja_m, ierr )
      implicit none
      integer nx, iparm(64), ierr
      real*8  v(nx), r(nx)
      integer :: ne_k, ia_k(nx+1), ja_k(ne_k)   
      integer :: ne_m, ia_m(nx+1), ja_m(ne_m)
      real*8  :: a_k(ne_k)
      real*8  :: a_m(ne_m)
      integer*8 pt(64)
      real*8 temp(nx)
      
      integer phase, idum(1)
      real*8 ddum(1)
c this routine does [I  0]-1[0  I]
c                   [0 -K]  [M  C] * v = r

c first multiply [0  I] * v = temp
c			   [M  C]

      temp(:) = 0.d0
      call mkl_dcsrgemv('n', nx, a_m, ia_m, ja_m, v, temp)

c	now do	 [I  0]-1 *temp = r (inverse is in value_k from a call to MKL_LU_SPARSE_INPUT)
c			 [0 -K]
      ierr = 0
      phase = 33
      iparm(6)=0 !to put computed solution in r
      r(:) = 0.d0
      call pardiso( pt, 1, 1, 11, phase, nx, a_k, ia_k, ja_k,
     &    idum, 1, iparm, 0, temp, r, ierr)
      if( ierr.ne.0 ) then
          ierr=0  !do on a separate line so debugger can be set to stop here 01/06/2016
      end if
      ierr=0 !added to not return -4 during arnoldi iterations with a singular UCS stiffness matrix.
c      open(6, access='append',file='unit6.txt')
c      write(6,*) 'av ',ierr
c      close(6)
      return
      end

!=======================================================================
      subroutine mkl_LU_factor2(nx, ne, a, ia, ja, pt, iparm, ierr)
      !only called from other fortran routines, not from Excel
      !called for damped eigs, and singular value response matrix
      !freept will need to be called after calling this 
      implicit none
      INCLUDE 'mkl_pardiso.f77'
!      USE mkl_pardiso
      integer nx, ne, ia(nx+1), ja(ne), ierr
      real*8 a(ne)
      integer*8  :: pt(64)
      integer iparm(64)

      integer idum(1), phase
      integer maxfct, mnum, nrhs, msglvl, mtype
      real*8  ddum(1)

C Factorize, results are saved by mkl and are accessed elsewhere via the pt array
      maxfct = 1
      mnum = 1
      nrhs = 1
      msglvl=0
      mtype = 11
      iparm(:) = 0
      
      phase = 11
      call pardiso( pt, maxfct, mnum, mtype, phase, nx, a, ia, ja, 
     &    idum, nrhs, iparm, msglvl, ddum, ddum, ierr)
      if( ierr.ne.0 ) return
      phase = 22
      call pardiso( pt, maxfct, mnum, mtype, phase, nx, a, ia, ja, 
     &    idum, nrhs, iparm, msglvl, ddum, ddum, ierr)
      return
      END

